/*
 * SLMPV : Gestion création de PV pour SOLIAMÈTRE SOLIA Concept
*
 *  Version 0.90
 *   Date        : 12/08/2021
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Ajout changement nom et description.
 *   	Ajout signature.
 *   	Passage NWJS.
 *   
 *  Version 0.82
 *   Date        : 15/10/2020
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Detection date de calibrage erronée.
 * 
 * 
 *   Version 0.81
 *   Date        : 11/01/2016
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Correction modele (firefox).
 *   
 * Version 0.8
 *   Date        : 24/12/2015
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Correction feuille de style.
 * 
 * Version 0.7
 *   Date        : 03/11/2015
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Ajout import direct CSV.
 *   
 * Version 0.6
 *   Date        : 15/05/2015
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Ajout zone saisie commentaire
 *   
 * Version 0.5
 *   Date        : 25/03/2015
 *   Auteur      : Cédric LE CORRE
 *   Commentaire : 
 *   	Ajout mode théorique.
 *   	Ajout mode analyse
 *   	Ajout mode comparaison
 *   	Correction modele PV : FR, EN, DE
 *   
 * Version 0.1
 *   Date        : 17/06/2014
 *   Auteur      : Erwan TOTH, Cédric LE CORRE
 *   Commentaire : Première release
 */

var version = "V0.90";

var lang_fr = {LG_PVESSAI:"Interface de gestion", LG_LANGUE:"Langue", LG_DATES:"Dates", LG_TAILLE:"Nb. élément", 
		   LG_PAGE:"Page", LG_BTSELCT:"Tout sélectioner", LG_BTDESELCT:"Tout déselectioner", LG_BTEDIT:"Création des PV sélectionnés",
		   LG_TBP_SELCT:"Sélection", LG_TBP_DATE:"Date", LG_TBP_FICHIER:"Fichier", LG_TBP_NOM:"Nom", LG_TBP_DESC:"Description",
		   LG_TBP_TOUT:"Tout",
		   LG_CRB_MES:"Mesure", LG_CRB_STC:"STC", LG_CRB_THEO:"Théorique",
		   LG_MES_ACCES:"Le navigateur n'a pas accès au fichier (voir Aide).\nPour Chrome : fermer complétement le navigateur chrome puis cliquer sur \"PV_Chrome\" à la racine de la carte SD pour lancer l'application.", LG_MES_SELECT:"Pas de mesure sélectionnée!",
		   //V0.5
		   LG_ANALYSER:"Analyser", LG_COMPARER:"Comparer", LG_PV:"PV", LG_THEORIQUE:"Théorique",  LG_CREERFICHIER:"Créer le fichier",
		   LG_BASEDEDONNEE:"Base de données",  LG_CRTHEO:"Création de fichier de données théoriques", LG_ERREUR:"Erreur", LG_SERIE:"Série", LG_STRING:"String",
		   LG_MES_SVGTH:"Le fichier doit être enregistré dans le répertoire TH_DATA de la carte SD.",  LG_RACMESURE:"Mes.", LG_RACTHEO:"Théo.",
		   LG_MODULE:"Module", LG_INSTALLATION:"Installation", LG_COEFTEMPERATURE:"Coefficient de température",
		   LG_CRBIV:"Courbe I-V", LG_CRBPV:"Courbe P-V", LG_THANLMES:"Analyse mesure",
		   LG_MESURES:"Mesures", LG_CORENSTC:"Corrigées en STC", LG_DELTA:"Delta", LG_RADIATION:"Radiation", LG_TEMPERATURE:"Température",
		   LG_THCOMPARMES:"Comparaison mesure",LG_MESSTC:"Mesure STC", LG_MESERREURLOAD:"Erreur chargement!",
		   LG_MESCOMPV:"Taper un commentaire qui apparaitra dans le PV...",
		   LG_MESIMPORTEXTERN:"Import fichier CSV",
		   LG_EFFACE:"Effacer", LG_SIGNATURE:"Signature",   LG_CONTROLEUR:"Contrôleur", LG_CLIENTPROP : "Client/Propriétaire", LG_SOCIETE : "Société", LG_NOM : "Nom", LG_VALIDER : "Valider", LG_ANNULER : "Annuler", 
		   LG_MESENR_OK:"Fichier sauvegardé dans TH_DATA !", LG_MESENR_DEF:"Erreur écriture !", LG_TBP_NOM_FICHIER:"Nom du fichier",
		   LG_MES_LIEN_LISTMEAS : "Sélectionner le fichier 'LISTMEAS.TXT' à la racine de carte SD de votre Soliamètre"
};

var lang_en = {LG_PVESSAI:"Management Interface", LG_LANGUE:"Language", LG_DATES:"Dates", LG_TAILLE:"Nb. element", 
	       LG_PAGE:"Page", LG_BTSELCT:"Select all", LG_BTDESELCT:"Unselect all", LG_BTEDIT:"Create selected test",
	       LG_TBP_SELCT:"Selection", LG_TBP_DATE:"Date", LG_TBP_FICHIER:"File", LG_TBP_NOM:"Name", LG_TBP_DESC:"Description",
	       LG_TBP_TOUT:"All",
	       LG_CRB_MES:"Measurement", LG_CRB_STC:"STC", LG_CRB_THEO:"Theoretical",
	       LG_MES_ACCES:"The browser has no access to the file (see Help).\nFor Chrome : completely close the Chrome browser and click \"PV_Chrome \" at the root of the SD card to start the application.", LG_MES_SELECT:"Not selected measurement!",
	       //V0.5
		   LG_ANALYSER:"Analyze", LG_COMPARER:"Compare", LG_PV:"PV", LG_THEORIQUE:"Theoretical",  LG_CREERFICHIER:"Create the file",
		   LG_BASEDEDONNEE:"Database",  LG_CRTHEO:"Creation of theoretical data file", LG_ERREUR:"Error", LG_SERIE:"Series", LG_STRING:"String",
		   LG_MES_SVGTH:"The file must be saved in the TH_DATA directory of the SD card.",  LG_RACMESURE:"Meas.", LG_RACTHEO:"Theo.", 
		   LG_MODULE:"Module", LG_INSTALLATION:"Installation", LG_COEFTEMPERATURE:"Temperature coefficient",
		   LG_CRBIV:"I-V curve", LG_CRBPV:"P-V curve", LG_THANLMES:"Analysis mode",
		   LG_MESURES:"Measurements", LG_CORENSTC:"STC corrections", LG_DELTA:"Delta", LG_RADIATION:"Radiation", LG_TEMPERATURE:"Temperature",
		   LG_THCOMPARMES:"Measurement comparison", LG_MESSTC:"STC meas.",
		   LG_MESCOMPV:"Type a comment that will appear in the report...",
		   LG_MESIMPORTEXTERN:"Import CSV file",
		   LG_EFFACE:"Clear", LG_SIGNATURE:"Signature",   LG_CONTROLEUR:"Controller", LG_CLIENTPROP : "Customer/Owner", LG_SOCIETE : "Company", LG_NOM : "Name", LG_VALIDER : "Validate", LG_ANNULER : "Cancel", 
		   LG_MESENR_OK:"File saved in TH_DATA !", LG_MESENR_DEF:"Write error !", LG_TBP_NOM_FICHIER:"Name of file",
		   LG_MES_LIEN_LISTMEAS : "Select the file 'LISTMEAS.TXT' in the SD card root of your Soliamètre"
};


var lang_de = {LG_PVESSAI:"Management Interface", LG_LANGUE:"Sprache", LG_DATES:"Datum", LG_TAILLE:"Nb. Element", 
	       LG_PAGE:"Seite", LG_BTSELCT:"Wählen Sie alle", LG_BTDESELCT:"Auswahl aufheben", LG_BTEDIT:"Erstellen ausgewählten Mess",
	       LG_TBP_SELCT:"Auswahl", LG_TBP_DATE:"Datum", LG_TBP_FICHIER:"File", LG_TBP_NOM:"Name", LG_TBP_DESC:"Beschreibung",
	       LG_TBP_TOUT:"Alle",
	       LG_CRB_MES:"Gemessene", LG_CRB_STC:"STC", LG_CRB_THEO:"Theoretische",
	       LG_MES_ACCES:"Der Browser hat keinen Zugriff auf die Datei (siehe Hilfe).", LG_MES_SELECT:"Nicht ausgewählte Mess!"
	       //V0.5
};


var nbPagesAff = 0;
var indexBase;
var index;
var pageTotal;
var tabLigne = document.getElementById('tableauLigne');
var nbElemDate = 0;
var ls_lang;
var fl_nwjs = false;
var root_sd = '../'; 

//define
var ID_PRMLIGNE=5;


function gest_lang()
{
	lang=document.getElementById('selectionLangue').value;
	
	switch(lang)
	{
	case 'fr':
		ls_lang = lang_fr;	
		break;
		
	  case 'en':
		  ls_lang = lang_en;	
		  break;
		  
	  case 'de':
		  ls_lang = lang_de;
		  break;
	}
	
	 
	var str = document.getElementById('idimg_help').title;
	document.getElementById('idimg_help').title = str.replace("*", version);
	document.getElementById('tbChLangue').rows[0].cells[0].innerHTML=ls_lang['LG_LANGUE'];
	document.getElementById('titre_pv').innerHTML=ls_lang['LG_PVESSAI'];
	document.getElementById('tbChDate').rows[0].cells[0].innerHTML=ls_lang['LG_DATES'];
	document.getElementById('tbChDate').rows[0].cells[1].innerHTML=ls_lang['LG_TAILLE'];
	document.getElementById('tbNbPages').rows[0].cells[0].innerHTML=ls_lang['LG_PAGE'];
	document.getElementById('btSelect').value=ls_lang['LG_BTSELCT'];
	document.getElementById('btDeselect').value=ls_lang['LG_BTDESELCT'];
	document.getElementById('selectionProces').value=ls_lang['LG_BTEDIT'];
	//tabLigne.rows[0].cells[0].innerHTML=ls_lang['LG_TBP_SELCT'];
	document.getElementById('selectionPagina').options[0].innerHTML=ls_lang['LG_TBP_TOUT'];
	tabLigne.rows[0].cells[1].innerHTML=ls_lang['LG_TBP_DATE'];
	document.getElementById('selectionDate').options[0].innerHTML=ls_lang['LG_TBP_TOUT'];
	tabLigne.rows[0].cells[0].innerHTML=ls_lang['LG_TBP_FICHIER'];
	tabLigne.rows[0].cells[2].innerHTML=ls_lang['LG_TBP_NOM'];
	tabLigne.rows[0].cells[3].innerHTML=ls_lang['LG_TBP_DESC'];
	
	document.getElementById('seltype_fn_0').value = ls_lang['LG_PV'];
	document.getElementById('seltype_fn_1').value = ls_lang['LG_THEORIQUE'];
	document.getElementById('seltype_fn_2').value = ls_lang['LG_ANALYSER'];
	document.getElementById('bt_creerfichier').value = ls_lang['LG_CREERFICHIER']; 
	
	document.getElementById('tb_import_extern').rows[0].cells[0].innerHTML=ls_lang['LG_MESIMPORTEXTERN'];
	
	document.getElementById('selcurs_crbc').options[0].innerHTML = ls_lang['LG_CRBIV'];
	document.getElementById('selcurs_crbc').options[1].innerHTML = ls_lang['LG_CRBPV'];
	
	document.getElementById('tb_curseur').rows[6].cells[0].innerHTML = ls_lang['LG_RACMESURE'];
	document.getElementById('tb_curseur').rows[6].cells[1].innerHTML = ls_lang['LG_CRB_STC'];
	document.getElementById('tb_curseur').rows[6].cells[2].innerHTML = ls_lang['LG_RACTHEO'];
	
	//théorique
	document.getElementById('tb_formul_titre').innerHTML = ls_lang['LG_CRTHEO'];
	document.getElementById('tb_creerth').rows[0].cells[0].innerHTML = ls_lang['LG_BASEDEDONNEE'];
	document.getElementById('tb_forml').rows[0].cells[0].innerHTML =  ls_lang['LG_TBP_NOM_FICHIER'];
	document.getElementById('tb_forml').rows[1].cells[0].innerHTML =  ls_lang['LG_TBP_NOM'];
	document.getElementById('tb_forml').rows[2].cells[0].innerHTML =  ls_lang['LG_TBP_DESC'];
	document.getElementById('tb_forml').rows[3].cells[0].innerHTML =  ls_lang['LG_MODULE'];
	document.getElementById('tb_forml').rows[6].cells[0].innerHTML =  ls_lang['LG_COEFTEMPERATURE'];
	document.getElementById('tb_forml').rows[9].cells[0].innerHTML =  ls_lang['LG_INSTALLATION'];
	document.getElementById('tb_forml').rows[10].cells[0].innerHTML =  ls_lang['LG_SERIE'];
	document.getElementById('tb_forml').rows[10].cells[3].innerHTML =  ls_lang['LG_STRING'];
	
	//analyse
	document.getElementById('tb_analys_titre').innerHTML = ls_lang['LG_THANLMES'];
	//document.getElementById('tb_recap_et').rows[0].cells[0].innerHTML = ls_lang['LG_THANLMES'];
	document.getElementById('txtComment').placeholder=ls_lang['LG_MESCOMPV'];
	
	
	document.getElementById('tb_recap').rows[0].cells[1].innerHTML = ls_lang['LG_MESURES'];
	document.getElementById('tb_recap').rows[0].cells[2].innerHTML = ls_lang['LG_CORENSTC'];
	document.getElementById('tb_recap').rows[0].cells[3].innerHTML = ls_lang['LG_THEORIQUE']; 
	document.getElementById('tb_recap').rows[0].cells[4].innerHTML = ls_lang['LG_DELTA']; 
	document.getElementById('tb_recap').rows[1].cells[0].innerHTML = ls_lang['LG_RADIATION']; 
	document.getElementById('tb_recap').rows[2].cells[0].innerHTML = ls_lang['LG_TEMPERATURE']; 
	
	//comparaison
	document.getElementById('tb_compar_titre').innerHTML = ls_lang['LG_THCOMPARMES']; 
	document.getElementById('tb_compar').rows[0].cells[1].innerHTML = ls_lang['LG_MESSTC']+" 1"; 
	document.getElementById('tb_compar').rows[0].cells[2].innerHTML = ls_lang['LG_MESSTC']+" 2"; 
	document.getElementById('tb_compar').rows[0].cells[3].innerHTML = ls_lang['LG_THEORIQUE']; 
	document.getElementById('tb_compar').rows[0].cells[4].innerHTML = ls_lang['LG_DELTA'];
	document.getElementById('tb_compar').rows[1].cells[0].innerHTML = ls_lang['LG_TBP_NOM'];
	document.getElementById('tb_compar').rows[2].cells[0].innerHTML = ls_lang['LG_TBP_DATE'];
	
	
	//signature
	
	document.getElementById('btn_signature').value = ls_lang['LG_SIGNATURE'] ;
	document.getElementById('tb_signature').rows[0].cells[0].innerHTML =  ls_lang['LG_CONTROLEUR'];
	document.getElementById('tb_signature').rows[0].cells[1].innerHTML = ls_lang['LG_CLIENTPROP'] ;
	document.getElementById('tb_signature').rows[1].cells[0].innerHTML = ls_lang['LG_SOCIETE'] ;
	document.getElementById('tb_signature').rows[1].cells[2].innerHTML = ls_lang['LG_SOCIETE'] ;
	document.getElementById('tb_signature').rows[2].cells[0].innerHTML = ls_lang['LG_NOM'] ;
	document.getElementById('tb_signature').rows[2].cells[2].innerHTML = ls_lang['LG_NOM'] ;
	
	document.getElementById('tb_signature').rows[3].cells[0].innerHTML = ls_lang['LG_SIGNATURE'] ;
	document.getElementById('tb_signature').rows[3].cells[2].innerHTML = ls_lang['LG_SIGNATURE'] ;
	
	
	document.getElementById('btn_clear_ctrl').innerText = ls_lang['LG_EFFACE'] ;
	document.getElementById('btn_clear_clt').innerText = ls_lang['LG_EFFACE'] ;
	
	document.getElementById('btn_valid_signature').innerText = ls_lang['LG_VALIDER'] ;
	document.getElementById('btn_annul_signature').innerText = ls_lang['LG_ANNULER'] ;
	document.getElementById('tb_lien_listmeas').rows[0].cells[0].innerHTML = ls_lang['LG_MES_LIEN_LISTMEAS'] ;
	
}


// activation des des fonctions au chargement de la page
window.onload = function () {
	
	init_params();
	gest_lang();
    stockLigne();
}

$("table").bind("sortStart",function() { 
}).bind("sortEnd",function() { 
	changePage();
});


function init_params()
{

		var obj=document.getElementById('selectionLangue');
		switch(lang)
		{
		  case 'fr':
			  obj.options[0].selected=true;
			  break;
			  
		  case 'en':
			  obj.options[1].selected=true;
			  break;
			  
		  case 'de':
			  obj.options[2].selected=true;
			  break;
		}
		
		
		if (typeof require === 'function') 
		{
			fl_nwjs = true;
		}
			
}


// fonction permettant le trie du tableau
function trie() {
	$('table').tablesorter();
};
// fonction permettant le remplissage du tableau, la récupération de la date



function stockLigne_preligne(preLigne)
{
	  var memDate = 0;
	   
	 var ligne = preLigne.split(/\n/g);
     var ligneAff;
     for (var i = ID_PRMLIGNE; i < ligne.length - 1; i++)
     {
         ligneAff = ligne[i];
         ligneTerm = ligne[i].split(';');
         dateAnnee = ligneTerm[0].substring(0, 4);
         dateMois = ligneTerm[0].substring(4, 6);
         dateJour = ligneTerm[0].substring(6, 8);
         dateComp = dateAnnee + '/' + dateMois + '/' + dateJour;
         var ligneTab = tabLigne.insertRow(1);
         
         if(i == ID_PRMLIGNE)
         	tabLigne.deleteRow(2);
         
         var checkboxCell = ligneTab.insertCell(0);
         var date = ligneTab.insertCell(1);
        // var nomFichier = ligneTab.insertCell(2);
         var nom = ligneTab.insertCell(2);
         var descrip = ligneTab.insertCell(3);
         j = i - ID_PRMLIGNE;
         checkboxCell.innerHTML = '<input class="stclick" onClick="gest_click()" type="checkbox" id="chbox_' + j + '" name="' + dateComp + '/' + ligneTerm[0] + '" >'+ligneTerm[0];
         date.innerHTML = dateComp;
        // nomFichier.innerHTML = ligneTerm[0];
         nom.innerHTML = ligneTerm[1];
         descrip.innerHTML = ligneTerm[2];
         if (memDate != dateComp)
         {
             memDate = dateComp;
             addOption(document.getElementById('selectionDate'), dateComp, dateComp);
         }
     }
     index = 0;
     indexBase = 0;
     pageTotal = i - ID_PRMLIGNE;
     trie();
     changePage();
}
   


function stockLigne() {

    if(fl_nwjs)
    {
    	const fs = require('fs');
    	
    	
    	//fs.writeFileSync synchronous attente
    	// write to a new file named 2pac.txt
    	fs.readFile(root_sd+'LISTMEAS.TXT', 'utf8', function(err, data) {
    	    // throws an error, you could also catch it here
    	    if (err) 
    	    {
    	    	//alert(ls_lang['LG_MES_ACCES']);  //
    	    	document.getElementById('div_lien_listmeas').style.display = "";
    	    	return;
    	    }
    	    	

    	    // success case, the file was saved
    	    //console.log('HTML saved!');
    	    stockLigne_preligne(data);
    	});
    }
    else
    {
	   var xhr = new XMLHttpRequest();
	    var ligneTerm = new Array();
	    xhr.open('GET', 'LISTMEAS.TXT', true);
	    
	    //xhr.onerror = function () { alert(ls_lang['LG_MES_ACCES']); }
	    xhr.onreadystatechange = function () {
	        if (xhr.readyState == 4)
	        {
	            var j = 0;
	            if(xhr.responseText == "" || xhr.status==404)
	            	{
	            	   alert(ls_lang['LG_MES_ACCES']);
	            	   return;
	            	}
	            	
	            
	            stockLigne_preligne(xhr.responseText);
	        }
	    }
	    xhr.timeout = 5000;
	    //ms
	    xhr.send(null);
    }
    
    
 
 
}


// fonction permettant la pagination avec les éléments "<" & ">", ainsi qu'avec le choix des tailles

function changePage() {
    nbElemDate = 0;
    var valSelect = document.getElementById('selectionDate') .value;
    var nbPages = parseInt(document.getElementById('selectionPagina') .value);
    for (index = 0; index < pageTotal; index++)
    {
        if (nbPages == - 1 && valSelect == - 1)
        {
            tabLigne.rows[index + 1].style.display = 'table-row';
        } 
        else if (valSelect == - 1)
        {
            if ((index >= indexBase) && (index < (indexBase + nbPages)))
            {
                tabLigne.rows[index + 1].style.display = 'table-row';
            } 
            else
            {
                tabLigne.rows[index + 1].style.display = 'none';
            }
        } 
        else
        {
            if (tabLigne.rows[index + 1].cells[1].innerHTML == valSelect)
            {
                if (((nbElemDate >= indexBase) && (nbElemDate < (indexBase + nbPages))) || (nbPages == - 1))
                {
                    tabLigne.rows[index + 1].style.display = 'table-row';
                } 
                else
                tabLigne.rows[index + 1].style.display = 'none';
                nbElemDate++;
            } 
            else
            {
                tabLigne.rows[index + 1].style.display = 'none';
            }
        }
    }
    if (nbPages == - 1)
    {
        document.getElementById('pageSuivante') .disabled = 'disabled';
        document.getElementById('pagePrecedente') .disabled = 'disabled';
    } 
    else if ((valSelect == - 1) || (nbPages == - 1))
    // désactivation de la navigation en fonction de certains critères
    {
        if (indexBase + nbPages > pageTotal)
        document.getElementById('pageSuivante') .disabled = 'disabled';
         else
        document.getElementById('pageSuivante') .disabled = false;
        if (indexBase == 0)
        document.getElementById('pagePrecedente') .disabled = 'disabled';
         else
        document.getElementById('pagePrecedente') .disabled = false;
    } 
    else
    {
        if (indexBase + nbPages > nbElemDate)
        document.getElementById('pageSuivante') .disabled = 'disabled';
         else
        document.getElementById('pageSuivante') .disabled = false;
        if (indexBase == 0)
        document.getElementById('pagePrecedente') .disabled = 'disabled';
         else
        document.getElementById('pagePrecedente') .disabled = false;
    }
    calculNbPage();
}
// réinitialisation de l'index suite au changement de page

function changeNbPage() {
    indexBase = 0;
    changePage();
}
// navigation des pages vers l'avant (+index)

function addIndex() {
    var nbPages = parseInt(document.getElementById('selectionPagina') .value);
    document.getElementById('pagePrecedente') .disabled = false;
    indexBase += nbPages;
    changePage();
}
// navigation des pages vers l'arrière (-index)

function soustracIndex() {
    var nbPages = parseInt(document.getElementById('selectionPagina') .value);
    document.getElementById('pageSuivante') .disabled = false;
    indexBase -= nbPages;
    if (indexBase < 0)
    indexBase = 0;
    changePage();
}
// crée une option dans la liste déroulante

function addOption(selectbox, value, text) {
    var optn = document.createElement('OPTION');
    optn.text = text;
    optn.value = value;
    selectbox.options.add(optn);
}
// permet la sélection du PV

function selectionPV() {
    var tb_mes = new Array();
    var j = 0;
    
    document.getElementById('txtnom').value = '';
    document.getElementById('txtdescription').value = '';
    
    for (var i = 0; i < pageTotal; i++)
    {
        var chBox = document.getElementById('chbox_' + i);
        if (chBox.checked == true)
        {
            tb_mes[j++] = chBox.name;
        }
    }
    
    if(j == 0)
    	alert(ls_lang['LG_MES_SELECT']);
    else
        creePV(tb_mes, false);
}
// calcul le nombre de pages

function calculNbPage() {
    var nbPages = parseInt(document.getElementById('selectionPagina') .value);
    if (nbPages == - 1)
    nbPagesAff = 1;
     else
    {
        if (document.getElementById('selectionDate') .value == - 1)
        nbPagesAff = parseInt(pageTotal / nbPages) + 1;
         else
        nbPagesAff = parseInt(nbElemDate / nbPages) + 1;
    }
    document.getElementById('tbNbPages') .rows[1].cells[3].innerHTML = nbPagesAff;
    document.getElementById('txtBoxPage') .value = (indexBase / nbPages) + 1;
}
// changement de page par text box

function tbChangePage() {
    var txtBox = parseInt(document.getElementById('txtBoxPage') .value);
    if (txtBox < 1)
    {
        txtBox = 1;
        document.getElementById('txtBoxPage') .value = txtBox;
    } 
    else if (txtBox > nbPagesAff)
    {
        txtBox = nbPagesAff;
        document.getElementById('txtBoxPage') .value = txtBox;
    }
    if (txtBox == nbPages)
    document.getElementById('pageSuivante') .disabled = 'disabled';
    var nbPages = parseInt(document.getElementById('selectionPagina') .value);
    document.getElementById('pagePrecedente') .disabled = false;
    indexBase = (txtBox - 1) * nbPages;
    changePage();
}
// selection de toutes les entrées

function selecTout() {
    for (var i = 0; i < pageTotal; i++)
    {
        var x = document.getElementsByName(tabLigne.rows[i + 1].cells[1].innerHTML + '/' + tabLigne.rows[i + 1].cells[0].innerText);
        if (tabLigne.rows[i + 1].style.display != 'none')
        {
            x[0].checked = true;
        } 
        else
        {
            x[0].checked = false;
        }
    }
    document.getElementById('btSelect') .style.display = 'none';
    document.getElementById('btDeselect') .style.display = 'block';
}
// deselection de toutes les entrées

function deselecTout() {
    for (var i = 0; i < pageTotal; i++)
    {
        var x = document.getElementsByName(tabLigne.rows[i + 1].cells[1].innerHTML + '/' + tabLigne.rows[i + 1].cells[0].innerText);
        if (x[0].checked == true)
        {
            x[0].checked = false;
        }
    }
    document.getElementById('btSelect') .style.display = 'block';
    document.getElementById('btDeselect') .style.display = 'none';
}
/*******************************************************************************************************************************************/
//Gestion PDF

var txtMdl = '';
var tabNomMesure = new Array();
var tabMesure = new Array();
var indexTabMesure=0;
var txt_anlsye= '';

// crée le PDF en fonction du PV sélectionner
function creePV(name, extern) 
{
    tabNomMesure=name;
    tabMesure = new Array();
    indexTabMesure=0;

    var strLang = lang.toUpperCase();

    if(fl_nwjs)
    {
    	const fs = require('fs');
    	
    	
    	//fs.writeFileSync synchronous attente
    	// write to a new file named 2pac.txt
    	fs.readFile('public/LibPV/Modele/Model_'+strLang+'.html', 'utf8', function(err, data) {
    	    // throws an error, you could also catch it here
    	    if (err) 
    	    {
    	    	alert(ls_lang['LG_MES_ACCES']);  //
    	    	throw err;
    	    	return;
    	    }
            txtMdl = data;
            
            if(extern)
            {
            	tabMesure[0]=gestBalise(txt_anlsye, indexTabMesure++);
            	creerPDF();
            }  	
            else
            	recupTabMesure();
    	});
    }
    else
    {
        var xhr = new XMLHttpRequest();
        var dt = new Date;
        
	    xhr.open('GET', 'LibPV/Modele/Model_'+strLang+'.html?superparam=' + dt.getTime());
	    xhr.setRequestHeader('If-None-Match', 'some-random-string');
	    xhr.setRequestHeader('Cache-Control', 'no-cache,max-age=0');
	    xhr.setRequestHeader('Pragma', 'no-cache');
	    xhr.setRequestHeader('Expires', '0');
	    xhr.onreadystatechange = function () {
	        if (xhr.readyState == 4)
	        {
	            txtMdl = xhr.responseText;
	            
	            if(extern)
	            {
	            	tabMesure[0]=gestBalise(txt_anlsye, indexTabMesure++);
	            	creerPDF();
	            }  	
	            else
	            	recupTabMesure();
	        }
	    }
	    xhr.timeout = 5000;
	    xhr.send(null);
    }
}

function recupTabMesure(){

  if(tabMesure.length < tabNomMesure.length)
  {
    recupMesure(tabNomMesure[tabMesure.length]);
  }
  else
  {
    creerPDF();
  }

}


function recupMesure(name)
{
	
   if(fl_nwjs)
   {
    	const fs = require('fs');
    	
    
    	fs.readFile(root_sd+name, 'utf8', function(err, data) {
	    if (err) 
	    {
	    	alert(ls_lang['LG_MESERREURLOAD']);
	    	throw err;
	    	return;
	    }
	    tabMesure[indexTabMesure] = gestBalise(data, indexTabMesure);
		indexTabMesure++;
		recupTabMesure();	  
    	});
   }
   else
   {
    var xhr = new XMLHttpRequest();
    var dt = new Date;

        xhr.open('GET', name + '?superparam=' + dt.getTime());
        xhr.setRequestHeader('If-None-Match', 'some-random-string');
        xhr.setRequestHeader('Cache-Control', 'no-cache,max-age=0');
        xhr.setRequestHeader('Pragma', 'no-cache');
        xhr.setRequestHeader('Expires', '0');
        xhr.onreadystatechange = function () {
          if (xhr.readyState == 4)
          {
          	  if(xhr.responseText.length == 0)
        	  {
        		  alert(ls_lang['LG_MESERREURLOAD']);
        		  return;
        	  }
          	  else
        	  {
                  tabMesure[indexTabMesure] = gestBalise(xhr.responseText, indexTabMesure);
                  indexTabMesure++;
                  recupTabMesure();	  
        	  }
          }
        }

        xhr.timeout = 5000;
        xhr.send(null);
   }
}
function Test_Exist(txt)
{
  if(txt==null)
	  return "";
  else
	  return txt;
}

function Test_Nb(nb)
{
  if(nb=="----")
	  return nb;
  else
	  return parseFloat(nb);
}


function calc_PrcDif(numSTC, numTheo)
{
	if( (isNaN(numSTC)) || (numSTC=="----") || (isNaN(numTheo)) || (numTheo=="----"))
		return "----";
	
	var diff=numSTC-numTheo;
	var prc=diff*100/numTheo;
	prc=prc.toFixed(2);
	return prc;
}

function calc_PrcDif_th(numSTC1, numSTC2, numTheo)
{
	if( (isNaN(numSTC1)) || (numSTC1=="----") || (isNaN(numSTC2)) || (numSTC2=="----") || (isNaN(numTheo)) || (numTheo=="----"))
		return "----";
	
	var diff=numSTC1-numSTC2;
	var prc=diff*100/numTheo;
	prc=prc.toFixed(2);
	return prc;
}

function gestBalise(donneeMesure, index_mesure) {
	
	var numSTC,numTheo;
	var ivcurve_mes = "";
	var ivcurve_stc = "";
	var ivcurve_theor = "";
	var pvcurve_mes = "";
	var pvcurve_stc = "";
	var pvcurve_theor = "";
	var ilgn=0, add_lgn=0;
	var fl_stc=true, fl_theor=true;
	
	var vmes,imes,pmes,vstc,istc,pstc,vtheor,itheor,ptheor;
	
    var cpyMdl = txtMdl;
    var ligneTerm;
    var data;
    var ligne = donneeMesure.split(/\n/g);
    
    //general
    cpyMdl = cpyMdl.replace(/#BLS_INDEX/g,index_mesure);
    
    
    // Tableau
    ilgn = 0;
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace(/#BLS_NUM_SERIE/g,ligneTerm[1]);
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace(/#BLS_NUM_VERSION/g,ligneTerm[1]);
    ligneTerm = ligne[ilgn++].split(';'); 
    if(ligneTerm[1].length < 10)
	{
			add_lgn = 1;
			ilgn++;
			ligneTerm[1] = "----/--/--"
	} 
    cpyMdl = cpyMdl.replace(/#BLS_DATE_CALIB/g,ligneTerm[1]);
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace(/#BLS_NAME_FILE/g,ligneTerm[0]);
    
    ligneTerm = ligne[ilgn++].split(';');  
    if(document.getElementById('txtnom').value != '')
    	cpyMdl = cpyMdl.replace('#BLS_PROJECT_NAME',document.getElementById('txtnom').value);
    else
    	cpyMdl = cpyMdl.replace('#BLS_PROJECT_NAME',ligneTerm[0]);
    
    ligneTerm = ligne[ilgn++].split(';');  
    if(document.getElementById('txtdescription').value != '')
    	cpyMdl = cpyMdl.replace('#BLS_PROJECT_DESCRIP',document.getElementById('txtdescription').value);
    else
    	cpyMdl = cpyMdl.replace('#BLS_PROJECT_DESCRIP',ligneTerm[0]);
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_PROJECT_DATE',ligneTerm[0]);
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_PROJECT_HOUR',ligneTerm[0]);
    
    ilgn = 12 + add_lgn;
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_REF_TYPE',ligneTerm[1]);
    ligneTerm = ligne[ilgn++].split(';');    
    cpyMdl = cpyMdl.replace('#BLS_RAD_MES', parseFloat(ligneTerm[1]));
    ligneTerm = ligne[ilgn].split(';');
    cpyMdl = cpyMdl.replace('#BLS_TEMP_MES', parseFloat(ligneTerm[1]));
    cpyMdl = cpyMdl.replace('#BLS_TEMP_UNITY',ligneTerm[2]);
    ilgn+=2;
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_ALPHA',parseFloat(ligneTerm[1]));
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_BETA',parseFloat(ligneTerm[1]));
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_K',parseFloat(ligneTerm[1]));
    
    ilgn = 24 + add_lgn;
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_VOC_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_VOC_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_VOC_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_VOC_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_ICC_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_ICC_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_ICC_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_ICC_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_VMPP_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_VMPP_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_VMPP_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_VMPP_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_IMPP_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_IMPP_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_IMPP_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_IMPP_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_PMPP_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace(/#BLS_PMPP_STC/g,numSTC);
    cpyMdl = cpyMdl.replace('#BLS_PMPP_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_PMPP_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn++].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_FF_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_FF_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_FF_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_FF_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ligneTerm = ligne[ilgn].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_RS_MES',parseFloat(ligneTerm[1]));
    numSTC=Test_Nb(ligneTerm[2]);
    numTheo=Test_Nb(ligneTerm[3]);
    cpyMdl = cpyMdl.replace('#BLS_RS_STC',numSTC);
    cpyMdl = cpyMdl.replace('#BLS_RS_THEO',numTheo);
    cpyMdl = cpyMdl.replace('#BLS_RS_DELTA',calc_PrcDif(numSTC,numTheo));
    
    ilgn+=2;
    ligneTerm = ligne[ilgn].split(';');  
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_1', Test_Exist(ligneTerm[1]));
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_2', Test_Exist(ligneTerm[2]));
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_3', Test_Exist(ligneTerm[3]));
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_4', Test_Exist(ligneTerm[4]));
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_5', Test_Exist(ligneTerm[5]));
    cpyMdl = cpyMdl.replace('#BLS_DEFAULT_6', Test_Exist(ligneTerm[6]));
    
    cpyMdl = cpyMdl.replace('#BLS_COMMENT', document.getElementById('txtComment').value);
    
    
   
    cpyMdl = cpyMdl.replace('#BLS_SIGNATURE_SOC_CTRL',document.getElementById('soc_ctrl').value);
    cpyMdl = cpyMdl.replace('#BLS_SIGNATURE_SOC_CLT',document.getElementById('soc_clt').value);
    cpyMdl = cpyMdl.replace('#BLS_SIGNATURE_NOM_CTRL',document.getElementById('nom_ctrl').value);
    cpyMdl = cpyMdl.replace('#BLS_SIGNATURE_NOM_CLT',document.getElementById('nom_clt').value);
    
    //---Courbe  V;I;P;Vstc;Istc;Pstc;Vthor;Itheor;Ptheor
    ilgn = 37 + add_lgn;
    for(var i=0;i<400;i++)
    {
    	ligneTerm = ligne[ilgn+i].split(';');
    	
    	vmes= parseFloat(ligneTerm[1]);//effaceZero(ligneTerm[1]);
    	imes=parseFloat(ligneTerm[2]);
        pmes=parseFloat(ligneTerm[3]);
        
        if (fl_stc) {
        	
        	if (ligneTerm[4] != null)
			   vstc = parseFloat(ligneTerm[4]);
			else
				fl_stc = false;
			
        	if(isNaN(vstc))
        		fl_stc = false;
			istc = parseFloat(ligneTerm[5]);
			pstc = parseFloat(ligneTerm[6]);
		}

    	
    	if (fl_theor) {

			if (ligneTerm[7] != null)
				vtheor = parseFloat(ligneTerm[7]);
			else
				fl_theor = false;
			
        	if(isNaN(vtheor))
        		fl_theor = false;
			itheor = parseFloat(ligneTerm[8]);
			ptheor = parseFloat(ligneTerm[9]);
		}
    	
    	if(i)
    	{
    		ivcurve_mes+=", ";
    		pvcurve_mes+=", ";
    		
    		if (fl_stc) {
				ivcurve_stc += ", ";
				pvcurve_stc += ", ";
			}
    		
    		if (fl_theor) {
    			ivcurve_theor+= ", ";
    			pvcurve_theor+= ", ";
			}
    	}
    	
    	ivcurve_mes += "["+vmes+", "+imes+"]"; 
    	pvcurve_mes += "["+vmes+", "+pmes+"]"; 
    	
		if (fl_stc) {
			ivcurve_stc += "["+vstc+", "+istc+"]"; 
			pvcurve_stc += "["+vstc+", "+pstc+"]"; 
		}
		
		if (fl_theor) {
			ivcurve_theor+= "["+vtheor+", "+itheor+"]"; 
			pvcurve_theor+= "["+vtheor+", "+ptheor+"]"; 
		}
    	
    }
    
	if (!fl_stc) {
		ivcurve_stc = "";
		pvcurve_stc = "";
	}
	
	if (!fl_theor) {
		ivcurve_theor = "";
		pvcurve_theor = "";
	}
    
    cpyMdl = cpyMdl.replace('#BLS_IVCRB_MES', ivcurve_mes);
    cpyMdl = cpyMdl.replace('#BLS_IVCRB_STC', ivcurve_stc);
    cpyMdl = cpyMdl.replace('#BLS_IVCRB_THEOR', ivcurve_theor);
    cpyMdl = cpyMdl.replace('#BLS_PVCRB_MES', pvcurve_mes); 
    cpyMdl = cpyMdl.replace('#BLS_PVCRB_STC', pvcurve_stc);
    cpyMdl = cpyMdl.replace('#BLS_PVCRB_THEOR', pvcurve_theor);
    
    return cpyMdl;
}


function creerFenetre(head_model)
{
	var str="";
    var myWindow = window.open('', '_blank'); //_blank _parent
    myWindow.document.write(head_model+"<body>");
    		
    		
    for(var i=0; i<tabMesure.length;i++)
    {
    	if(i == 1)
    		str ='<p class="breakhere"> </p></br>';
    	
    	  myWindow.document.write(str + tabMesure[i]);
    }
    
    
    var img_ctrl = document.getElementById("canvas_ctrl").toDataURL("image/png;base64;");
    var img_clt =  document.getElementById("canvas_clt").toDataURL("image/png;base64;");
    
    myWindow.document.write("<script type=\"text/javascript\">" +
    		"var nb_crb="+tabMesure.length+";\n" +
    		"var LG_CRB_MES=\""+ls_lang['LG_CRB_MES']+"\";\n" +
    		"var LG_CRB_STC=\""+ls_lang['LG_CRB_STC']+"\";\n" +
    		"var LG_CRB_THEO=\""+ls_lang['LG_CRB_THEO']+"\";\n" +
    		"var fl_nwjs="+fl_nwjs+";\n"+
    		"var data_img_ctrl='"+img_ctrl+"';\n"+
    		"var data_img_clt='"+img_clt+"';\n"+
    		"</script>\n</body>\n</html>");
    
    var script = document.createElement("script");
    script.type="text/javascript";
    if(fl_nwjs)
    	script.src = "public/LibPV/Lib/ecrcourbe.js";
    else
    	script.src = "LibPV/Lib/ecrcourbe.js";
    
    myWindow.stop();
    myWindow.document.getElementsByTagName("head")[0].parentNode.appendChild(script);
}


function creerPDF(tb_txt) {
	
	
	 if(fl_nwjs)
	 {
    	const fs = require('fs');
	

		fs.readFile('public/LibPV/Modele/ModelH.html', 'utf8', function(err, data) {
		if (err) 
		{
			alert(ls_lang['LG_MESERREURLOAD']);
			throw err;
			return;
		}
    	var head_model = data;
    	creerFenetre(head_model); 
		});
	 }
	 else
	{
		var xhr = new XMLHttpRequest();
	    var dt = new Date;
	    
	    xhr.open('GET', 'LibPV/Modele/ModelH.html?superparam=' + dt.getTime());
	    xhr.setRequestHeader('If-None-Match', 'some-random-string');
	    xhr.setRequestHeader('Cache-Control', 'no-cache,max-age=0');
	    xhr.setRequestHeader('Pragma', 'no-cache');
	    xhr.setRequestHeader('Expires', '0');
	    xhr.onreadystatechange = function () {
	        if (xhr.readyState == 4)
	        {
	        	var head_model = xhr.responseText;
	        	creerFenetre(head_model);
	        }
	    }
	    xhr.timeout = 5000;
	    xhr.send(null);
	}
}

//---Gestion creation fichier donnee theorique
function seltype_fn(type)
{
	if(type == 0)
	{
		document.getElementById('seltype_fn_0').disabled='disabled';
		document.getElementById('seltype_fn_0').disabled='disabled';
		document.getElementById('seltype_fn_1').disabled='';
		document.getElementById('tableauLigne').style.display='table';
		document.getElementById('tb_forml').style.display='none';
		document.getElementById('tbChDate').style.display='table';
		document.getElementById('tbNbPages').style.display='table';
		document.getElementById('tb_selprc').style.display='table';	
		document.getElementById('tb_import_extern').style.display='';
	}
	else
	{
		document.getElementById('seltype_fn_0').disabled='';
		document.getElementById('tableauLigne').style.display='none';
		document.getElementById('tbChDate').style.display='none';
		document.getElementById('tbNbPages').style.display='none';
		document.getElementById('tb_selprc').style.display='none';
		document.getElementById('tb_import_extern').style.display='none';
	}
	
	if(type == 1)
	{
		document.getElementById('seltype_fn_1').disabled='disabled';
		document.getElementById('tb_forml').style.display='table';
		document.getElementById('tb_creerth').style.display='table';
		document.getElementById('tb_formul_titre').style.display=''; 
		//document.getElementById('bt_import_donth').value=document.location.href; 
	}
	else
	{
		document.getElementById('seltype_fn_1').disabled='';	
		document.getElementById('tb_forml').style.display='none';
		document.getElementById('tb_creerth').style.display='none';
		document.getElementById('tb_formul_titre').style.display='none'; 
	}
	
	if(type == 2)
	{ 
		document.getElementById('tb_analys_titre').style.display='';
		document.getElementById('tb_recap_et').style.display='';
		document.getElementById('tb_recap').style.display='';
		document.getElementById('tb_pdfcsv').style.display='';
		document.getElementById('tb_curseur').style.top='450px';
	}
	else
	{
		document.getElementById('tb_analys_titre').style.display='none';
		document.getElementById('tb_pdfcsv').style.display='none';
		document.getElementById('tb_recap_et').style.display='none';
		document.getElementById('tb_recap').style.display='none';
	}
	
	
	if(type == 3)
	{ 
		document.getElementById('tb_compar').style.display='';
		document.getElementById('tb_compar_titre').style.display='';
		document.getElementById('tb_curseur').style.top='300px';
	}
	else
	{
		document.getElementById('tb_compar').style.display='none';
		document.getElementById('tb_compar_titre').style.display='none';
	}
	
	
	if((type == 0) || (type == 2) || (type == 3) )
		document.getElementById('btn_signature').style.display='';
	else
		document.getElementById('btn_signature').style.display='none';
	
	
	if((type == 2) || (type == 3))
	{
		document.getElementById('seltype_fn_2').disabled='disabled';
		document.getElementById('anlcrb_iv').style.display='';
		document.getElementById('tb_curseur').style.display='';
	}
	else
	{
		gest_click();
		document.getElementById('anlcrb_iv').style.display='none';
		document.getElementById('tb_curseur').style.display='none';
	}
		
}


function import_donth(evt)
{
    var dt = new Date;
    var obj = document.getElementById('bt_import_donth');
    var value;
    
	var f = evt.target.files[0]; 

    if (f) {
      var r = new FileReader();
      r.onload = function(e) { 
	      var txt = e.target.result;
        /*alert( "Got the file.n" 
              +"name: " + f.name + "n"
              +"type: " + f.type + "n"
              +"size: " + f.size + " bytesn"
              + "starts with: " + txt.substr(1, txt.indexOf("n"))
        ); */
	      
		if(txt.substr(0,10) != "Soliametre")
		   return;
    	var ligne = txt.split(/\n/g);
    	var ligneTerm, vmes;
    	
    	var nom_fichier = f.name.split('.');
    	document.getElementById('dth_15').value = nom_fichier[0];
    		
    	
    	ligneTerm = ligne[1].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	document.getElementById('dth_0').value = ligneTerm[0];
    	ligneTerm = ligne[2].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	document.getElementById('dth_1').value = ligneTerm[0];
    	
    	ligneTerm = ligne[3].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_6').value = value.toFixed(3);
    	
    	
    	ligneTerm = ligne[4].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_7').value = value.toFixed(3);
    	
    	
    	ligneTerm = ligne[5].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_8').value = value.toFixed(2);
    	
    	
    	ligneTerm = ligne[6].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_2').value = value.toFixed(2);
    	
    	ligneTerm = ligne[7].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_3').value = parseFloat(ligneTerm[0]);
    	
    	ligneTerm = ligne[8].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_4').value = parseFloat(ligneTerm[0]);
    	
    	ligneTerm = ligne[9].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	value = parseFloat(ligneTerm[0]);
    	document.getElementById('dth_5').value = parseFloat(ligneTerm[0]);
    	
    	ligneTerm = ligne[10].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	document.getElementById('dth_9').value = parseInt(ligneTerm[0]);
    	
    	ligneTerm = ligne[11].split(':');
    	ligneTerm = ligneTerm[1].split(';');
    	document.getElementById('dth_10').value = parseInt(ligneTerm[0]);
      }
      r.readAsText(f);
    } else { 
      alert("Failed to load file");
    }
    
    /*
    var tb = obj.value;
    tb = tb.split('\\');
    xhr.open('GET', 'TH_DATA/'+tb[tb.length-1]); //+document.getElementById('bt_import_donth').value
    xhr.onreadystatechange = function () 
    {
        if (xhr.readyState == 4)
        {
      	  if(xhr.responseText.length == 0)
    	  {
    		  alert(ls_lang['LG_MESERREURLOAD']);
    		  return;
    	  }
      	  

        	
        	
        }
    }
    xhr.timeout = 5000;
    xhr.send(null);
	*/
}



function test_min_max(val, min, max)
{
	 if(isNaN(val) || val < min || val > max)
		 return false;
	 
	 
	 return true;
}




String.prototype.strtr = function(from,to)
{
// Initialisation
var length = 0;
var hash = new Array();
var tmp = "";

// Taille de la chaine la plus longue ?
if (from.length < to.length)
length = from.length;
else
length = to.length;

// Création de la table d'équivalence...
for (var i=0; i<length; i++) {
hash[from.charAt(i)] = to.charAt(i);
}

// Conversion...
for (var j=0; j<this.length; j++) {
var c = this.charAt(j);
if (hash[c])
tmp = tmp + hash[this.charAt(j)];
else
tmp = tmp + c;
}

// retourne le résultat
return tmp;
}


function rm_accent(str)
{
	var res = str.strtr(' àáâãäçèéêëìíîïñòóôõöùúûüýÿÀÁÂÃÄÇÈÉÊËÌÍÎÏÑÒÓÔÕÖÙÚÛÜÝ','_aaaaaceeeeiiiinooooouuuuyyAAAAACEEEEIIIINOOOOOUUUUY');
		
	return nom = res.replace(/[^a-z0-9-_\.]+/gi, "");
}

function creer_donth($table, filename)
{
	var csv, csvData, signe, zero;	
	document.getElementById('blsa_dwn').href = "javascript:void(0)";
	
	
	
	var nom_fichier = document.getElementById('dth_15').value;
	if(nom_fichier.length <= 0 || nom_fichier.length > 8 )
	{
		alert(ls_lang['LG_ERREUR'] + " : " + ls_lang['LG_TBP_NOM_FICHIER']+"." );
		return;
	}
	
	var nom = document.getElementById('dth_0').value;
	
	if(nom.length <= 0)
	{
		alert(ls_lang['LG_ERREUR'] + " : " + ls_lang['LG_TBP_NOM']+"." );
		return;
	}
	
	var alpha = parseFloat(document.getElementById('dth_6').value);
	if(!test_min_max(alpha, -10, 10))
	{
		alert(ls_lang['LG_ERREUR'] + " alpha.\nMin: -10; Max: 10 %/°C.");
		return;
	}
	
	var beta = parseFloat(document.getElementById('dth_7').value);
	if(!test_min_max(beta, -10, 10))
	{
		alert(ls_lang['LG_ERREUR'] + " Beta.\nMin: -10; Max: 10 %/°C.");
		return;
	}
	
	var coef_k = parseFloat(document.getElementById('dth_8').value);
	if(!test_min_max(coef_k, -100, 100))
	{
		alert(ls_lang['LG_ERREUR'] + " k.\nMin: -100; Max: 100 e-3/°C.");
		return;
	}
	
	var voc = parseFloat(document.getElementById('dth_2').value);
	if(!test_min_max(voc, 0, 1000))
	{
		alert(ls_lang['LG_ERREUR'] + " Voc.\nMin: 0; Max: 1000Vcc.");
		return;
	}
	
	var isc = parseFloat(document.getElementById('dth_3').value);
	if(!test_min_max(isc, 0, 24))
	{
		alert(ls_lang['LG_ERREUR'] + " Isc.\nMin: 0; Max: 24A.");
		return;
	}
	
	var vmpp = parseFloat(document.getElementById('dth_4').value);
	if(!test_min_max(vmpp, 0, voc))
	{
		alert(ls_lang['LG_ERREUR'] + " Vmpp.\nMin: 0; Max: Voc.");
		return;
	}
	
	
	var impp = parseFloat(document.getElementById('dth_5').value);
	if(!test_min_max(impp, 0, isc))
	{
		alert(ls_lang['LG_ERREUR'] + " impp.\nMin: 0; Max: Isc.");
		return;
	}
	
	var serie = parseInt(document.getElementById('dth_9').value);
	if(!test_min_max(serie, 0, 99))
	{
		alert(ls_lang['LG_ERREUR'] + " " + ls_lang['LG_SERIE']+".\nMin: 1; Max: 99.");
		return;
	}
	
	var string = parseInt(document.getElementById('dth_10').value);
	if(!test_min_max(string, 0, 99))
	{
		alert(ls_lang['LG_ERREUR'] + " " +ls_lang['LG_STRING']+".\nMin: 1; Max: 99.");
		return;
	}
	
	
	
	csv="Soliametre;\r\n";
    csv+="Name:"+nom+";\r\n";
    csv+="Description:"+document.getElementById('dth_1').value+";\r\n";
    signe = alpha >= 0 ? '+' : '';
    csv+="A:"+signe+alpha.toFixed(3)+";\r\n";
    signe = beta >= 0 ? '+' : '';
    csv+="B:"+signe+beta.toFixed(3)+";\r\n";
    signe = coef_k >= 0 ? '+' : '';
    csv+="K:"+signe+coef_k.toFixed(3)+";\r\n";
    csv+="Voc:+"+voc.toFixed(2)+";\r\n";
    csv+="Isc:+"+isc.toFixed(2)+";\r\n";
    csv+="Vmpp:+"+vmpp.toFixed(2)+";\r\n";
    csv+="Impp:+"+impp.toFixed(2)+";\r\n";
    zero = serie < 10 ? '0' : '';
    csv+="Serie:"+zero+serie+";\r\n";
    zero = string < 10 ? '0' : '';
    csv+="String:"+zero+string+";\r\n";

	
	
	csvData = 'data:application/csv;charset=utf-8,' + encodeURIComponent(csv);

	
	if(fl_nwjs)
	{
		const fs = require('fs');
		
		fs.writeFile(root_sd+'TH_DATA/'+rm_accent(nom_fichier.substring(0,8)) + '.TXT', csv, function(err) {
			 if (err)
			 {
				document.getElementById('blsa_dwn').download = rm_accent(nom_fichier.substring(0,8)) + '.TXT';
				document.getElementById('blsa_dwn').href = csvData;
				document.getElementById('blsa_dwn').target = 'blank';
				alert(ls_lang['LG_MES_SVGTH']);
				document.getElementById('blsa_dwn').click();
			  }
			  else
				  alert(ls_lang['LG_MESENR_OK']);
			});
	}
	else
	{
		document.getElementById('blsa_dwn').download = rm_accent(nom_fichier.substring(0,8)) + '.TXT';
		document.getElementById('blsa_dwn').href = csvData;
		document.getElementById('blsa_dwn').target = 'blank';
		alert(ls_lang['LG_MES_SVGTH']);
		document.getElementById('blsa_dwn').click();
	}
		
}

//---Gestion analsye

var updateLegendTimeout = null;
var latestPosition = null;
var plot, type_crb=0;
var point_curseur=0;
var ivcurve_mes_recap = new Array();
var ivcurve_stc_recap  = new Array();
var ivcurve_theor_recap  = new Array();
var pvcurve_mes_recap  = new Array();
var pvcurve_stc_recap  = new Array();
var pvcurve_theor_recap = new Array();

var ivcurve_stc_cmp = new Array();
var pvcurve_stc_cmp = new Array();
var index_courbe_cmp = 0;

var id_tsmesel;





function dwn_csv()
{
	document.getElementById('btn_csv').href = "javascript:void(0)";
	//csvData = 'data:application/csv;charset=utf-8,' + encodeURIComponent(csv);
	
	for (var i = 0; i < pageTotal; i++)
	{
	    var chBox = document.getElementById('chbox_' + i);
	    if (chBox.checked == true)
	    {

	    	var nom = chBox.name.split("/");
	    	document.getElementById('btn_csv').download = nom[nom.length-1];
	    	document.getElementById('btn_csv').href = chBox.name;
	    	break;
	    }	
	}
}


function pad(num, size) {
    var s = num+"";
    while (s.length < size) 
    	s = '0' + s;
    return s;
}

function updateLegend() {

	updateLegendTimeout = null;

	var pos = latestPosition;

	var axes = plot.getAxes();
	if (pos.x < axes.xaxis.min || pos.x > axes.xaxis.max ||
		pos.y < axes.yaxis.min || pos.y > axes.yaxis.max) {
		return;
	}

	var i, j, dataset = plot.getData();
	for (i = 0; i < dataset.length; ++i) {

		var series = dataset[i];
		for (j = series.data.length-1; j > 0; j--) {
			if (series.data[j][0] > pos.x) {
				break;
			}
		}
		var y,
			p1 = series.data[j - 1],
			p2 = series.data[j];

		if (p1 == null) {
			y = p2[1];
		} else if (p2 == null) {
			y = p1[1];
		} else 
		{
			if((p2[0] == p1[0]) || (p2[1] == p1[1]))
				  y = p1[1];
			else
				y = p1[1] + (p2[1] - p1[1]) * (pos.x - p1[0]) / (p2[0] - p1[0]);
		}

		var val_aff = y.toFixed(0);
		
		if(type_crb == 0)
			val_aff = y.toFixed(2);
		
		$("#placeholder .legendLabel").eq(i).text(series.label.replace(/=.*/, "= " + val_aff));

	}

	var obj_x = document.getElementById('aff_posx').innerHTML;
	document.getElementById('aff_posx').innerHTML = obj_x.replace(/=.*/, "= " + pos.x.toFixed(2)+" Vcc");
}
	


function rch_max_crb(tt_crb, index)
{
	var val, crb;
	var max = new Array();
	max = [0,0];
	
	for(var j=0; j<tt_crb.length;j++)
	{
		crb = tt_crb[j].data;
		for(var i=0; i < crb.length; i++)
		{
			val = crb[i];
			
			if(val[0] > max[0] )
				max[0]  = val[0];
			
			if(val[1] > max[1] )
				max[1]  = val[1] ;
		}
	}

	
	return max;
}

function switch_point_curseur(id_voie)
{
	switch(id_voie)
	{
	case 0:
		if(document.getElementById('btn_crs0').checked)
		{
			document.getElementById('btn_crs1').checked = false;
			point_curseur = 0;
		}
		else
		{
			document.getElementById('btn_crs1').checked = true;
			point_curseur = 1;
		}
		break;

	case 1:
		if(document.getElementById('btn_crs1').checked)
		{
			document.getElementById('btn_crs0').checked = false;
			point_curseur = 1;
		}
		else
		{
			document.getElementById('btn_crs0').checked = true;
			point_curseur = 0;
		}
		break;
		
	}
}


function switch_typecourbe(obj_crb)
{
	type_crb=obj_crb.value;
	analyse_crb();
}

var tb_crosshair = [{ x: -1, y: -1 , c: "#000000"}, { x: -1, y: -1, c:"#FF0000"}];


function efface_curseur()
{
	plot.draw();
	tb_crosshair[0].x = -1;
	document.getElementById('aff_c1').style.display='none';
	tb_crosshair[1].x = -1;
	document.getElementById('aff_c2').style.display='none';
}



function dsn_curseur(item)
{
	var o = plot.pointOffset({ x: item.datapoint[0], y: item.datapoint[1]});
	var plotOffset = plot.getPlotOffset();
	var axes = plot.getAxes();
    var offset = plot.offset();
    var canvas = plot.getCanvas(); 
    var ctx = canvas.getContext('2d');
    
	if (point_curseur == 0) 
	{
		document.getElementById('aff_c1').style.left = (o.left - 15) + "px";
		document.getElementById('aff_c1').style.top = (o.top + 5) + "px";
		document.getElementById('aff_c1').style.display='';
	    tb_crosshair[0].x = o.left - plotOffset.left; 
	    tb_crosshair[0].y =o.top - plotOffset.top;
	} 
	else 
	{
		document.getElementById('aff_c2').style.left = (o.left - 15) + "px";
		document.getElementById('aff_c2').style.top = (o.top + 5) + "px";
		document.getElementById('aff_c2').style.display='';
		tb_crosshair[1].x = o.left - plotOffset.left; 
		tb_crosshair[1].y =o.top - plotOffset.top;
	}
	
	plot.draw();

	for(var i=0;i<2;i++)
	{
		var crosshair = tb_crosshair[i];
		if(crosshair.x != -1)
		{
		    ctx.save();
		    ctx.translate(plotOffset.left, plotOffset.top);
		    ctx.strokeStyle = crosshair.c;
		    ctx.lineWidth = "1";
		    ctx.lineJoin = "round";
		    ctx.beginPath();
	//	    ctx.moveTo(crosshair.x, plot.height());
	//	    ctx.lineTo(crosshair.x, crosshair.y);
	//	    ctx.moveTo(0, crosshair.y);
	//	    ctx.lineTo(crosshair.x, crosshair.y); 
		    ctx.moveTo(crosshair.x, 0);
		    ctx.lineTo(crosshair.x, plot.height());
		    ctx.moveTo(0, crosshair.y);
		    ctx.lineTo(plot.width(), crosshair.y);
		    
		 
		    ctx.stroke();
		    ctx.restore();
		}
	}
}


function zoom_out (event) 
{
	var axis = plot.getXAxes();
	var opts = axis[0].options;
	dataset = plot.getData();
	var max = rch_max_crb(dataset, 0);
	
	opts.min = 0;
	opts.max = max[0] * 1.1;

	
	axis = plot.getYAxes();
	opts = axis[0].options;
	opts.min = 0;
	opts.max = max[1] * 1.1;
	
	
		plot.setupGrid();
		efface_curseur(); //plot.draw();	
}


function plot_selected(event, ranges) {
	if (ranges.xaxis.to - ranges.xaxis.from < 0.00001) {
		ranges.xaxis.to = ranges.xaxis.from + 0.00001;
	}

	if (ranges.yaxis.to - ranges.yaxis.from < 0.00001) {
		ranges.yaxis.to = ranges.yaxis.from + 0.00001;
	}

	var axis = plot.getXAxes();
	var opts = axis[0].options;
	opts.min = ranges.xaxis.from;
	opts.max = ranges.xaxis.to;

	
	axis = plot.getYAxes();
	opts = axis[0].options;
	opts.min = ranges.yaxis.from;
	opts.max = ranges.yaxis.to;

	plot.setupGrid();
	efface_curseur(); //plot.draw();
    plot.clearSelection();
}


function plot_click (event, pos, item) {
	var obj_tbc = document.getElementById('tb_curseur');
	var val_aff;
	if(item)
	{
		dsn_curseur(item);
		
		x = item.datapoint[0].toFixed(2);
		if(type_crb == 0)
			y = item.datapoint[1].toFixed(2);
		else
			y =  item.datapoint[1].toFixed(0);
		
		
		obj_tbc.rows[2 + point_curseur].cells[2].innerHTML=x;
		obj_tbc.rows[2 + point_curseur].cells[3].innerHTML=y;

		if(point_curseur == 0)
		{
			document.getElementById('btn_crs1').checked = true;
			switch_point_curseur(1);
		}
		else
		{
			document.getElementById('btn_crs0').checked = true;
			switch_point_curseur(0);
		}
		
		var pa1 = parseFloat(obj_tbc.rows[2].cells[2].innerHTML);
		var pb1 = parseFloat(obj_tbc.rows[2].cells[3].innerHTML);

		if(isNaN(pa1) || isNaN(pb1))
				return;
		
		
		var pa2 = parseFloat(obj_tbc.rows[3].cells[2].innerHTML);
		var pb2 = parseFloat(obj_tbc.rows[3].cells[3].innerHTML);

		if(isNaN(pa2) || isNaN(pb2))
			return;
		
		var d1 = pa2 - pa1;
		var d2 = pb2 - pb1;
		
		
		obj_tbc.rows[4].cells[2].innerHTML = d1.toFixed(2);
		
		

		val_aff = d2.toFixed(0);
		
		if(type_crb == 0)
			val_aff = d2.toFixed(2);
		
		obj_tbc.rows[4].cells[3].innerHTML = val_aff;
	}
}


function gest_updatelegend(event, pos, item) {
	latestPosition = pos;
	if (!updateLegendTimeout) {
		updateLegendTimeout = setTimeout(updateLegend, 50);
	}
}


function analyse_crb()
{
	var fl_init=false;
	var fn_tick, lgd_pos;

	var tb_data = new Array();
	var txt_mes, txt_stc;
	var index_crb=0;
	
	if(type_crb == 0)
	{	
		document.getElementById('tb_curseur').rows[1].cells[2].innerHTML = "y (A)";
		
		if(index_courbe_cmp == 0)
		{
			txt_mes =ls_lang['LG_RACMESURE'] + "(A)= 00.00";
			txt_stc = "STC(A)= 00.00";
			document.getElementById('tb_curseur').rows[6].cells[0].innerHTML = ls_lang['LG_RACMESURE'];
			document.getElementById('tb_curseur').rows[6].cells[1].innerHTML = ls_lang['LG_CRB_STC'];
		}
		else
		{
			txt_mes = "STC_1(A)= 00.00";
			txt_stc = "STC_2(A)= 00.00";
			document.getElementById('tb_curseur').rows[6].cells[0].innerHTML = ls_lang['LG_CRB_STC'] + " 1";
			document.getElementById('tb_curseur').rows[6].cells[1].innerHTML = ls_lang['LG_CRB_STC'] + " 2";
		}
		
		if(document.getElementById('crbact_mes').checked)
			tb_data[index_crb++] = { label: txt_mes, data: ivcurve_mes_recap,  color: "#0000FF"};
		
		if((ivcurve_stc_recap.length > 0) && document.getElementById('crbact_stc').checked)
		  tb_data[index_crb++] = { label: txt_stc, data: ivcurve_stc_recap,  color: "#00FF00" };
		else
			document.getElementById('crbact_stc').checked = false;
		
		if((ivcurve_theor_recap.length > 0) && document.getElementById('crbact_theo').checked)
		  tb_data[index_crb++] = { label: "Theo(A)= 00.00", data: ivcurve_theor_recap,  color: "#800080" } ;
		else
			document.getElementById('crbact_theo').checked = false;
		
		fn_tick = function(v, axis) {return v.toFixed(axis.tickDecimals) + " A";};
		lgd_pos = "sw";
	}
	else
	{
		document.getElementById('tb_curseur').rows[1].cells[2].innerHTML = "y (W)";
		if(index_courbe_cmp == 0)
		{
			txt_mes = ls_lang['LG_RACMESURE'] +"(W)= 00000";
			txt_stc = "STC(W)= 00000";
			document.getElementById('tb_curseur').rows[6].cells[0].innerHTML = ls_lang['LG_RACMESURE'];
			document.getElementById('tb_curseur').rows[6].cells[1].innerHTML = ls_lang['LG_CRB_STC'];
		}
		else
		{
			txt_mes = "STC_1(W)= 00000";
			txt_stc = "STC_2(W)= 00000";
			document.getElementById('tb_curseur').rows[6].cells[0].innerHTML = ls_lang['LG_CRB_STC'] + " 1";
			document.getElementById('tb_curseur').rows[6].cells[1].innerHTML = ls_lang['LG_CRB_STC'] + " 2";
		}
		
		if(document.getElementById('crbact_mes').checked)
			tb_data[index_crb++] = { label: txt_mes, data: pvcurve_mes_recap,  color: "#0000FF"};
		
		if((pvcurve_stc_recap.length > 0) && document.getElementById('crbact_stc').checked)
			tb_data[index_crb++] = { label: txt_stc, data: pvcurve_stc_recap,  color: "#00FF00" };
		else
			document.getElementById('crbact_stc').checked = false;
			
		
		if((pvcurve_theor_recap.length > 0) && document.getElementById('crbact_theo').checked)
			tb_data[index_crb++] = { label: "Theo.(W)= 00.00", data: pvcurve_theor_recap,  color: "#800080" } ;
		else
			document.getElementById('crbact_theo').checked = false;
		
		fn_tick = function(v, axis) {return v.toFixed(axis.tickDecimals) + " W";};
		lgd_pos = "nw";
	}
	
	if(plot !== undefined)
	{
		var opt_plot = plot.getOptions();
		 
		var axis = plot.getYAxes();
		var opts = axis[0].options;
		
		opts.tickFormatter = fn_tick;
		opt_plot.legend.position = lgd_pos;  
		plot.setData(tb_data);
		
		
		dataset = plot.getData();
		var max = rch_max_crb(dataset, 0);
		
		axis = plot.getXAxes();
		opts = axis[0].options;
		opts.min = 0;
		opts.max = max[0] * 1.1;

		
		axis = plot.getYAxes();
		opts = axis[0].options;
		opts.min = 0;
		opts.max = max[1] * 1.1;
 		
 		plot.setupGrid();
 		efface_curseur(); //plot.draw();	
		return;
	}
	
	plot = $.plot($("#placeholder"), tb_data, {
		  yaxes: [
	    {			
			position : 'left',
			tickFormatter: fn_tick
		  }],
		  xaxes: [
		  { 
			tickFormatter: function(v, axis) {return v.toFixed(axis.tickDecimals) + " Vcc";}
	    } ],
		series: {
			shadowSize: 0	
		},
		
		grid: {
		    backgroundColor: "#FFF", // { colors:  [ "#eee", "#eee" ]}
			hoverable: true,
			clickable: true,
			margin:{top:20}
		},
		
		selection: {
			mode: "xy",
			color:"#23a0e9"
		},
		crosshair: {
		mode: 'x'
	  },
	  legend:{
		  position: lgd_pos
	  }
	});

	$("<div class='cursaff' id='aff_c1' style='display:none; left:100px; top:-5px'>A</div>")
	.appendTo($("#placeholder"));

	$("<div class='cursaff' id='aff_c2' style='background-color:#FF0000; display:none; left:100px; top:-5px'>B</div>")
	.appendTo($("#placeholder"));

	$("<div class='posx' id='aff_posx' style='left:30px; top:-5px'>V = </div>")
	.appendTo($("#placeholder"));

	$("<div class='button' style='right:130px; top:-5px'>Cursor off</div>")
	.appendTo($("#placeholder"))
	.click(efface_curseur);
	
	
	$("<div class='button' style='right:30px; top:-5px'>Zoom out</div>")
	.appendTo($("#placeholder"))
	.click(zoom_out);



	$("#placeholder").bind("plothover", gest_updatelegend);
	$("#placeholder").bind("plotselected", plot_selected);
	$("#placeholder").bind("plotclick", plot_click);
}


function decode_anlyse(donneeMesure)
{
	 var obj_tb = document.getElementById('tb_recap');
	 var obj_tbet = document.getElementById('tb_recap_et');
	 var obj_compar = document.getElementById('tb_compar');
	  
	  var idcell_compar = 1 + (index_courbe_cmp*2);
	  var numSTC,numTheo;
	  var ilgn=0, add_lgn=0;
	  
		
		var fl_stc=true, fl_theor=true;
		
		var vmes,imes,pmes,vstc,istc,pstc,vtheor,itheor,ptheor;
	    var ligneTerm;
	    var data;
	    /*var donneeMesure = xhr.responseText;*/
	    txt_anlsye = donneeMesure;
	    if(txt_anlsye.substr(0,10) != "Soliametre")
	    	return;
	    
	    var ligne = donneeMesure.split(/\n/g);
	   
	    ilgn=0;
	    ligneTerm = ligne[ilgn++].split(';');  

	    //cpyMdl = cpyMdl.replace(/#BLS_NUM_SERIE/g,ligneTerm[1]);
	    ligneTerm = ligne[ilgn++].split(';');  
	    //cpyMdl = cpyMdl.replace(/#BLS_NUM_VERSION/g,ligneTerm[1]);
	    ligneTerm = ligne[ilgn++].split(';');  
	    if(ligneTerm[1].length < 10)
	    {
			add_lgn = 1;
			ilgn++;
		}
	    //cpyMdl = cpyMdl.replace(/#BLS_DATE_CALIB/g,ligneTerm[1]);
	    ligneTerm = ligne[ilgn++].split(';');  
	    
	    
	    
	    //cpyMdl = cpyMdl.replace(/#BLS_NAME_FILE/g,ligneTerm[0]);
	    ligneTerm = ligne[ilgn++].split(';');  
	    document.getElementById('txtnom').value  = ligneTerm[0]; 
	    obj_compar.rows[1].cells[1 + index_courbe_cmp].innerHTML = ligneTerm[0];
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    document.getElementById('txtdescription').value   =ligneTerm[0];
	    obj_compar.rows[1].cells[1 + index_courbe_cmp].title = ligneTerm[0];
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tbet.rows[0].cells[1].innerHTML =ligneTerm[0];
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tbet.rows[0].cells[1].innerHTML+=" "+ligneTerm[0];
	    obj_compar.rows[2].cells[1 + index_courbe_cmp].innerHTML = obj_tbet.rows[0].cells[1].innerHTML;
	    
	    ilgn = 32 + add_lgn;
	    ligneTerm = ligne[ilgn].split(';');  
	    obj_tbet.rows[2].cells[0].innerHTML = Test_Exist(ligneTerm[1]);
	    obj_tbet.rows[2].cells[1].innerHTML = Test_Exist(ligneTerm[2]);
	    obj_tbet.rows[3].cells[0].innerHTML = Test_Exist(ligneTerm[3]);
	    obj_tbet.rows[3].cells[1].innerHTML = Test_Exist(ligneTerm[4]);
	    obj_tbet.rows[4].cells[0].innerHTML = Test_Exist(ligneTerm[5]);
	    obj_tbet.rows[4].cells[1].innerHTML = Test_Exist(ligneTerm[6]);
	    
	    ilgn = 12 + add_lgn;
	    ligneTerm = ligne[ilgn++].split(';');  
	    //cpyMdl = cpyMdl.replace('#BLS_REF_TYPE',ligneTerm[1]);
	    ligneTerm = ligne[ilgn++].split(';');    
	    obj_tb.rows[1].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    ligneTerm = ligne[ilgn++].split(';');
	    obj_tb.rows[2].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    obj_tb.rows[2].cells[2].innerHTML = ligneTerm[2];
	    ilgn = 16 + add_lgn;
	    ligneTerm = ligne[ilgn++].split(';');  
	    //cpyMdl = cpyMdl.replace('#BLS_ALPHA',parseFloat(ligneTerm[1]));
	    ligneTerm = ligne[ilgn++].split(';');  
	    //cpyMdl = cpyMdl.replace('#BLS_BETA',parseFloat(ligneTerm[1]));
	    ligneTerm = ligne[ilgn++].split(';');  
	    //cpyMdl = cpyMdl.replace('#BLS_K',parseFloat(ligneTerm[1]));
	    
	    ilgn = 24 + add_lgn;
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[5].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[5].cells[3].innerHTML =numSTC;
	    obj_compar.rows[5].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[5].cells[5].innerHTML =numTheo;
	    obj_compar.rows[5].cells[5].innerHTML = numTheo;
	    obj_tb.rows[5].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    

	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[6].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[6].cells[3].innerHTML =numSTC;
	    obj_compar.rows[6].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[6].cells[5].innerHTML =numTheo;
	    obj_compar.rows[6].cells[5].innerHTML = numTheo;
	    obj_tb.rows[6].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[7].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[7].cells[3].innerHTML =numSTC;
	    obj_compar.rows[7].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[7].cells[5].innerHTML =numTheo;
	    obj_compar.rows[7].cells[5].innerHTML = numTheo;
	    obj_tb.rows[7].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[8].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[8].cells[3].innerHTML =numSTC;
	    obj_compar.rows[8].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[8].cells[5].innerHTML =numTheo;
	    obj_compar.rows[8].cells[5].innerHTML = numTheo;
	    obj_tb.rows[8].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[9].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[9].cells[3].innerHTML =numSTC;
	    obj_compar.rows[9].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[9].cells[5].innerHTML =numTheo;
	    obj_compar.rows[9].cells[5].innerHTML = numTheo;
	    obj_tb.rows[9].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[4].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[4].cells[3].innerHTML =numSTC;
	    obj_compar.rows[4].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[4].cells[5].innerHTML =numTheo; 
	    obj_compar.rows[4].cells[5].innerHTML = numTheo;
	    obj_tb.rows[4].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	    ligneTerm = ligne[ilgn++].split(';');  
	    obj_tb.rows[3].cells[1].innerHTML = parseFloat(ligneTerm[1]);
	    numSTC=Test_Nb(ligneTerm[2]);
	    numTheo=Test_Nb(ligneTerm[3]);
	    obj_tb.rows[3].cells[3].innerHTML =numSTC;
	    obj_compar.rows[3].cells[idcell_compar].innerHTML = numSTC;
	    obj_tb.rows[3].cells[5].innerHTML =numTheo;
	    obj_compar.rows[3].cells[5].innerHTML = numTheo;
	    obj_tb.rows[3].cells[7].innerHTML =calc_PrcDif(numSTC,numTheo);
	    
	
	    if(index_courbe_cmp == 1)
	    {
	    	ivcurve_stc_cmp = [];
	    	ivcurve_stc_cmp = ivcurve_stc_recap.slice(0);
	    	pvcurve_stc_cmp = [];
	    	pvcurve_stc_cmp = pvcurve_stc_recap.slice(0);
	    }
	    	
	    
	    ivcurve_mes_recap   = [];
	    ivcurve_stc_recap   = [];
	    ivcurve_theor_recap = [];
	    pvcurve_mes_recap   = [];
	    pvcurve_stc_recap   = [];
	    pvcurve_theor_recap = [];
	        
	  //---Courbe  V;I;P;Vstc;Istc;Pstc;Vthor;Itheor;Ptheor
	  
	    ilgn = 37 + add_lgn;
	    for(var i=0;i<400;i++)
	    {
	    	ligneTerm = ligne[ilgn+i].split(';');
	    	
	    	vmes= parseFloat(ligneTerm[1]);//effaceZero(ligneTerm[1]);
	    	imes=parseFloat(ligneTerm[2]);
	        pmes=parseFloat(ligneTerm[3]);
	        
	        if (fl_stc) {
	        	
	        	if (ligneTerm[4] != null)
				   vstc = parseFloat(ligneTerm[4]);
				else
					fl_stc = false;
				
	        	if(isNaN(vstc))
	        		fl_stc = false;
				istc = parseFloat(ligneTerm[5]);
				pstc = parseFloat(ligneTerm[6]);
			}
	
	    	
	    	if (fl_theor) {
	
				if (ligneTerm[7] != null)
					vtheor = parseFloat(ligneTerm[7]);
				else
					fl_theor = false;
				
	        	if(isNaN(vtheor))
	        		fl_theor = false;
				itheor = parseFloat(ligneTerm[8]);
				ptheor = parseFloat(ligneTerm[9]);
			}
	    	
	    	ivcurve_mes_recap.push([vmes, imes]); 
	    	pvcurve_mes_recap.push([vmes, pmes]); 
	    	
			if (fl_stc) {
				ivcurve_stc_recap.push([vstc, istc]); 
				pvcurve_stc_recap.push([vstc, pstc]); 
			}
			
			if (fl_theor) {
				ivcurve_theor_recap.push([vtheor, itheor]);
				pvcurve_theor_recap.push([vtheor, ptheor]);
			}
	    }
	    
		if (!fl_stc) {
			ivcurve_stc = [];
			pvcurve_stc = [];
		}
		
		if (!fl_theor) {
			ivcurve_theor = [];
			pvcurve_theor = [];
		}
		
	        if(index_courbe_cmp == 1)
	        {
	        	ivcurve_mes_recap = []; //la courbe mes correspon a la courbe 1 stc
	        	ivcurve_mes_recap = ivcurve_stc_cmp.slice(0);
	        	pvcurve_mes_recap = [];
	        	pvcurve_mes_recap = pvcurve_stc_cmp.slice(0);
	        }
		
		
		if(index_courbe_cmp == 0)
		{
			test_compare();
			if(index_courbe_cmp == 0)
			{
				seltype_fn(2);
				analyse_crb();
			}
				
		}
		else
		{
			seltype_fn(3);
			gest_deltacomp();
			analyse_crb();
		}
}

function creer_pv_anlyse()
{
	creePV('',true);
}



function import_extern(evt)
{
	var f = evt.target.files[0]; 

    if (f) {
      var r = new FileReader();
      r.onload = function(e) { 
	      var contents = e.target.result;
        /*alert( "Got the file.n" 
              +"name: " + f.name + "n"
              +"type: " + f.type + "n"
              +"size: " + f.size + " bytesn"
              + "starts with: " + contents.substr(1, contents.indexOf("n"))
        );  */
	      
    	  if(contents.length == 0)
    	  {
    		  alert(ls_lang['LG_MESERREURLOAD']);
    		  return;
    	  }
    	  decode_anlyse(contents);
      };
      r.readAsText(f);
    } else { 
    	alert(ls_lang['LG_MESERREURLOAD']);
    }
}



function load_anlsye(name)
{
	
	 if(fl_nwjs)
	 {
    	const fs = require('fs');
	

		fs.readFile(root_sd+name, 'utf8', function(err, data) {
		if (err) 
		{
			alert(ls_lang['LG_MESERREURLOAD']);
			throw err;
			return;
		}
		 decode_anlyse(data);
		});
	 }
	else
	{
		var xhr = new XMLHttpRequest();
		var dt = new Date;
		
		xhr.open('GET', name + '?superparam=' + dt.getTime());
		xhr.setRequestHeader('If-None-Match', 'some-random-string');
		xhr.setRequestHeader('Cache-Control', 'no-cache,max-age=0');
		xhr.setRequestHeader('Pragma', 'no-cache');
		xhr.setRequestHeader('Expires', '0');
		xhr.onreadystatechange = function () 
		{
		  if (xhr.readyState == 4)
		  {
			  if(xhr.responseText.length == 0)
			  {
				  alert(ls_lang['LG_MESERREURLOAD']);
				  return;
			  }
			  decode_anlyse(xhr.responseText);
		  }
		};
		
		xhr.timeout = 5000;
		xhr.send(null);
	}
}

function gest_deltacomp()
{
	 var obj_compar = document.getElementById('tb_compar');
	 var numSTC1, numSTC2, numtheo;

	 
	switch(parseInt(document.getElementById('type_comp').value))
	{
	case 0:
		for(var i=3; i<10; i++)
		{
			numSTC1 = parseFloat(obj_compar.rows[i].cells[1].innerHTML);
			numSTC2 = parseFloat(obj_compar.rows[i].cells[3].innerHTML);
			numtheo = parseFloat(obj_compar.rows[i].cells[5].innerHTML);
			obj_compar.rows[i].cells[7].innerHTML = calc_PrcDif_th(numSTC1,numSTC2, numtheo);
		}
		break;
		
	case 1:
		for(var i=3; i<10; i++)
		{
			numSTC1 = parseFloat(obj_compar.rows[i].cells[3].innerHTML);
			numSTC2 = parseFloat(obj_compar.rows[i].cells[1].innerHTML);
			numtheo = parseFloat(obj_compar.rows[i].cells[5].innerHTML);
			obj_compar.rows[i].cells[7].innerHTML = calc_PrcDif_th(numSTC1,numSTC2, numtheo);
		}
		break;
		
	case 2:
		for(var i=3; i<10; i++)
		{
			numSTC1 = parseFloat(obj_compar.rows[i].cells[1].innerHTML);
			numtheo = parseFloat(obj_compar.rows[i].cells[5].innerHTML);
			obj_compar.rows[i].cells[7].innerHTML = calc_PrcDif(numSTC1,numtheo);
		}
		break;
		
	case 3:
		for(var i=3; i<10; i++)
		{
			numSTC1 = parseFloat(obj_compar.rows[i].cells[3].innerHTML);
			numtheo = parseFloat(obj_compar.rows[i].cells[5].innerHTML);
			obj_compar.rows[i].cells[7].innerHTML = calc_PrcDif(numSTC1,numtheo);
		}
		break;
	}
	
}

function test_compare()
{
	for (id_tsmesel=id_tsmesel+1; id_tsmesel < pageTotal; id_tsmesel++)
	{
	    var chBox = document.getElementById('chbox_' + id_tsmesel);
	    if (chBox.checked == true)
	    {
	    	index_courbe_cmp = 1;
	        load_anlsye(chBox.name);
	        return;
	    }
	}
}

function anlsye_mesel()
{
	
	var tb_mes = new Array();
	var j = 0;
	
	
	
	for (id_tsmesel = 0; id_tsmesel < pageTotal; id_tsmesel++)
	{
	    var chBox = document.getElementById('chbox_' + id_tsmesel);
	    if (chBox.checked == true)
	    {
	    	index_courbe_cmp = 0;
	        load_anlsye(chBox.name);
	        return
	    }
	}
	
	alert(ls_lang['LG_MES_SELECT']);
}


function gest_click()
{
	var nb_sel = 0;
	
	for (var i = 0; i < pageTotal; i++)
	{
	    var chBox = document.getElementById('chbox_' + i);
	    if (chBox.checked == true)
	    {
	    	nb_sel++;
	    	if(nb_sel > 2)
	    		break;
	    }
	    	
	}
	
	if(nb_sel == 1)
	{
		document.getElementById('seltype_fn_2').value = ls_lang['LG_ANALYSER'];
		document.getElementById('seltype_fn_2').disabled='';
	}
	else if(nb_sel == 2)
	{
		document.getElementById('seltype_fn_2').value = ls_lang['LG_COMPARER'];
		document.getElementById('seltype_fn_2').disabled='';
	}
	else
	{
		document.getElementById('seltype_fn_2').value = ls_lang['LG_ANALYSER'];
		document.getElementById('seltype_fn_2').disabled='disabled';
	}
}


// find position in canvas, from mouse event
function getXY(canvas, evt) 
{
    const rect = canvas.getBoundingClientRect();
    const x = evt.clientX - rect.left;
    const y = evt.clientY - rect.top;
    return {x, y};
}


function componentToHex(c) 
{
    const hex = Number(c).toString(16);
    return hex.length == 1 ? "0" + hex : hex;
}

function rgbToHex(r, g, b) 
{
    return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
}


function sign_onmousedown(evt0, obj) 
{

    // get brush parameters from range elements
    const r = 0;
    const g = 0;
    const b = 0;
    const color = rgbToHex(r, g, b);
    const radius = 0.5;
    
    // get canvas context and initial position
    const ctx = obj.getContext("2d");
    let p0 = getXY(obj, evt0);

    // set callback function for mousemove event
    obj.onmousemove = function(evt1) {
        // draw a line from previous position to current position
        const p1 = getXY(obj, evt1);
        ctx.beginPath();
        ctx.strokeStyle = color
        ctx.fillStyle = color;
        ctx.lineWidth = 2 * radius;
        ctx.lineCap = "round";
        ctx.moveTo(p0.x, p0.y);
        ctx.lineTo(p1.x, p1.y);
        ctx.fill();
        ctx.stroke();
        // update position 
        p0 = p1;
    };
}

function sign_onmouseup(event, obj) 
{
	obj.onmousemove = {};
}

function sign_clear(id)
{
	var obj = document.getElementById(id);
	const width = obj.clientWidth;
    const height = obj.clientHeight;
    const ctx = obj.getContext("2d");
    ctx.beginPath();
    ctx.clearRect(0, 0, width, height);
    ctx.stroke();
}

function aff_signature(obj_btn)
{
	var obj = document.getElementById('div_signature');
	if(obj.style.display=="none")
		obj.style.display="";
	else
		signature_annul();
		
}

function signature_valid()
{
	document.getElementById('div_signature').style.display="none";
}

function signature_annul()
{
	document.getElementById('soc_ctrl').value = '';
	document.getElementById('soc_clt').value  = '';
	document.getElementById('nom_ctrl').value = '';
	document.getElementById('nom_clt').value  = '';
	sign_clear('canvas_ctrl');
	sign_clear('canvas_clt');
	document.getElementById('div_signature').style.display="none";
}

function chx_lien_listmeas(evt)
{
	var f = evt.target.files[0]; 

    if (f) 
    {
      var r = new FileReader();
      r.onload = function(e) { 
	      var contents = e.target.result;
        /*alert( "Got the file.n" 
              +"name: " + f.name + "n"
              +"type: " + f.type + "n"
              +"size: " + f.size + " bytesn"
              + "starts with: " + contents.substr(1, contents.indexOf("n"))
        );  */
	      
      
		  if((contents.length == 0) || f.name != "LISTMEAS.TXT")
		  {
			  alert(ls_lang['LG_MESERREURLOAD']);
			  return;
		  } 
		  
		  var str_path =  f.path;
		  root_sd = str_path.replace("LISTMEAS.TXT", "");;
		  document.getElementById('div_lien_listmeas').style.display="none";
		  
		  stockLigne_preligne(contents);   
		
      };
      r.readAsText(f);
    } else { 
    	alert(ls_lang['LG_MES_ACCES']); 
    	document.getElementById('div_lien_listmeas').style.display="none";
    }
}

